"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var _class = function () {
    function _class() {
        var mutationFunction = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : function (phenotype) {
            return phenotype;
        };
        var crossoverFunction = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : function (a, b) {
            return [a, b];
        };
        var fitnessFunction = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : function (phenotype) {
            return 0;
        };
        var isABetterThanBFunction = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : undefined;
        var population = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : [];
        var populationSize = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 100;
        var chanceOfMutation = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : 50;

        _classCallCheck(this, _class);

        this.mutationFunction = mutationFunction;
        this.crossoverFunction = crossoverFunction;
        this.fitnessFunction = fitnessFunction;
        this.isABetterThanBFunction = isABetterThanBFunction;
        this.population = population;
        this.populationSize = populationSize;
        this.chanceOfMutation = chanceOfMutation;
    }

    _createClass(_class, [{
        key: "populate",
        value: function populate() {
            var size = this.population.length;
            while (this.population.length < this.populationSize) {
                this.population.push(this.mutate(this.population[Math.floor(Math.random() * size)]));
            }
        }
    }, {
        key: "mutate",
        value: function mutate(phenotype) {
            return this.mutationFunction(phenotype);
        }
    }, {
        key: "crossover",
        value: function crossover(phenotype) {
            var randomIndex = Math.floor(Math.random() * this.population.length);
            var matePhenotype = this.population[randomIndex];
            return this.crossoverFunction(phenotype, matePhenotype)[0];
        }
    }, {
        key: "isABetterThanB",
        value: function isABetterThanB(a, b) {
            var isABetterThanB = false;
            if (this.isABetterThanBFunction) {
                return this.isABetterThanBFunction(a, b);
            }
            return this.fitnessFunction(a) >= this.fitnessFunction(b);
        }
    }, {
        key: "compete",
        value: function compete() {
            var nextGeneration = [];

            for (var p = 0; p < this.population.length - 1; p += 2) {
                var phenotype = this.population[p];
                var competitor = this.population[p + 1];

                if (this.isABetterThanB(phenotype, competitor)) {
                    if (Math.random() < this.chanceOfMutation / 100) {
                        nextGeneration.push(this.mutate(phenotype));
                    } else {
                        nextGeneration.push(this.crossover(phenotype));
                    }
                } else {
                    nextGeneration.push(competitor);
                }
            }

            this.population = nextGeneration;
        }
    }, {
        key: "mixPopulationOrder",
        value: function mixPopulationOrder() {

            for (var index = 0; index < this.population.length; index++) {
                var newIndex = Math.floor(Math.random() * this.population.length);
                var tempPhenotype = this.population[newIndex];
                this.population[newIndex] = this.population[index];
                this.population[index] = tempPhenotype;
            }
        }
    }, {
        key: "evolve",
        value: function evolve() {
            this.populate();
            this.mixPopulationOrder();
            this.compete();
        }
    }, {
        key: "best",
        value: function best() {
            var myFitnessFunction = this.fitnessFunction;
            var theBest = this.population.reduce(function (previousPhenotype, currentPhenotype) {
                var previousFitness = myFitnessFunction(previousPhenotype);
                var currentFitness = myFitnessFunction(currentPhenotype);
                return previousFitness >= currentFitness ? previousPhenotype : currentPhenotype;
            });

            return theBest;
        }
    }]);

    return _class;
}();

exports.default = _class;